<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>SessionTrackerImpl.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">Code Coverage for Zookeeper manuall provided Classes</a> &gt; <a href="index.source.html" class="el_package">org.apache.zookeeper.server</a> &gt; <span class="el_source">SessionTrackerImpl.java</span></div><h1>SessionTrackerImpl.java</h1><pre class="source lang-java linenums">/**
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * &quot;License&quot;); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an &quot;AS IS&quot; BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.zookeeper.server;

import java.io.PrintWriter;
import java.io.StringWriter;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Date;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Map.Entry;
import java.util.concurrent.ConcurrentHashMap;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.apache.zookeeper.KeeperException;
import org.apache.zookeeper.KeeperException.SessionExpiredException;

/**
 * This is a full featured SessionTracker. It tracks session in grouped by tick
 * interval. It always rounds up the tick interval to provide a sort of grace
 * period. Sessions are thus expired in batches made up of sessions that expire
 * in a given interval.
 */
public class SessionTrackerImpl extends ZooKeeperCriticalThread implements SessionTracker {
<span class="fc" id="L43">    private static final Logger LOG = LoggerFactory.getLogger(SessionTrackerImpl.class);</span>

<span class="fc" id="L45">    HashMap&lt;Long, SessionImpl&gt; sessionsById = new HashMap&lt;Long, SessionImpl&gt;();</span>

<span class="fc" id="L47">    HashMap&lt;Long, SessionSet&gt; sessionSets = new HashMap&lt;Long, SessionSet&gt;();</span>

    ConcurrentHashMap&lt;Long, Integer&gt; sessionsWithTimeout;
<span class="fc" id="L50">    long nextSessionId = 0;</span>
    long nextExpirationTime;

    int expirationInterval;

    public static class SessionImpl implements Session {
<span class="fc" id="L56">        SessionImpl(long sessionId, int timeout, long expireTime) {</span>
<span class="fc" id="L57">            this.sessionId = sessionId;</span>
<span class="fc" id="L58">            this.timeout = timeout;</span>
<span class="fc" id="L59">            this.tickTime = expireTime;</span>
<span class="fc" id="L60">            isClosing = false;</span>
<span class="fc" id="L61">        }</span>

        final long sessionId;
        final int timeout;
        long tickTime;
        boolean isClosing;

        Object owner;

<span class="fc" id="L70">        public long getSessionId() { return sessionId; }</span>
<span class="fc" id="L71">        public int getTimeout() { return timeout; }</span>
<span class="fc" id="L72">        public boolean isClosing() { return isClosing; }</span>
    }

    public static long initializeNextSession(long id) {
<span class="fc" id="L76">        long nextSid = 0;</span>
<span class="fc" id="L77">        nextSid = (System.currentTimeMillis() &lt;&lt; 24) &gt;&gt;&gt; 8;</span>
<span class="fc" id="L78">        nextSid =  nextSid | (id &lt;&lt;56);</span>
<span class="fc" id="L79">        return nextSid;</span>
    }

<span class="fc" id="L82">    static class SessionSet {</span>
<span class="fc" id="L83">        HashSet&lt;SessionImpl&gt; sessions = new HashSet&lt;SessionImpl&gt;();</span>
    }

    SessionExpirer expirer;

    private long roundToInterval(long time) {
        // We give a one interval grace period
<span class="fc" id="L90">        return (time / expirationInterval + 1) * expirationInterval;</span>
    }

    public SessionTrackerImpl(SessionExpirer expirer,
            ConcurrentHashMap&lt;Long, Integer&gt; sessionsWithTimeout, int tickTime,
            long sid, ZooKeeperServerListener listener)
    {
<span class="fc" id="L97">        super(&quot;SessionTracker&quot;, listener);</span>
<span class="fc" id="L98">        this.expirer = expirer;</span>
<span class="fc" id="L99">        this.expirationInterval = tickTime;</span>
<span class="fc" id="L100">        this.sessionsWithTimeout = sessionsWithTimeout;</span>
<span class="fc" id="L101">        nextExpirationTime = roundToInterval(System.currentTimeMillis());</span>
<span class="fc" id="L102">        this.nextSessionId = initializeNextSession(sid);</span>
<span class="fc bfc" id="L103" title="All 2 branches covered.">        for (Entry&lt;Long, Integer&gt; e : sessionsWithTimeout.entrySet()) {</span>
<span class="fc" id="L104">            addSession(e.getKey(), e.getValue());</span>
<span class="fc" id="L105">        }</span>
<span class="fc" id="L106">    }</span>

<span class="fc" id="L108">    volatile boolean running = true;</span>

    volatile long currentTime;

    synchronized public void dumpSessions(PrintWriter pwriter) {
<span class="fc" id="L113">        pwriter.print(&quot;Session Sets (&quot;);</span>
<span class="fc" id="L114">        pwriter.print(sessionSets.size());</span>
<span class="fc" id="L115">        pwriter.println(&quot;):&quot;);</span>
<span class="fc" id="L116">        ArrayList&lt;Long&gt; keys = new ArrayList&lt;Long&gt;(sessionSets.keySet());</span>
<span class="fc" id="L117">        Collections.sort(keys);</span>
<span class="fc bfc" id="L118" title="All 2 branches covered.">        for (long time : keys) {</span>
<span class="fc" id="L119">            pwriter.print(sessionSets.get(time).sessions.size());</span>
<span class="fc" id="L120">            pwriter.print(&quot; expire at &quot;);</span>
<span class="fc" id="L121">            pwriter.print(new Date(time));</span>
<span class="fc" id="L122">            pwriter.println(&quot;:&quot;);</span>
<span class="fc bfc" id="L123" title="All 2 branches covered.">            for (SessionImpl s : sessionSets.get(time).sessions) {</span>
<span class="fc" id="L124">                pwriter.print(&quot;\t0x&quot;);</span>
<span class="fc" id="L125">                pwriter.println(Long.toHexString(s.sessionId));</span>
<span class="fc" id="L126">            }</span>
<span class="fc" id="L127">        }</span>
<span class="fc" id="L128">    }</span>

    @Override
    synchronized public String toString() {
<span class="nc" id="L132">        StringWriter sw = new StringWriter();</span>
<span class="nc" id="L133">        PrintWriter pwriter = new PrintWriter(sw);</span>
<span class="nc" id="L134">        dumpSessions(pwriter);</span>
<span class="nc" id="L135">        pwriter.flush();</span>
<span class="nc" id="L136">        pwriter.close();</span>
<span class="nc" id="L137">        return sw.toString();</span>
    }

    @Override
    synchronized public void run() {
        try {
<span class="fc bfc" id="L143" title="All 2 branches covered.">            while (running) {</span>
<span class="fc" id="L144">                currentTime = System.currentTimeMillis();</span>
<span class="fc bfc" id="L145" title="All 2 branches covered.">                if (nextExpirationTime &gt; currentTime) {</span>
<span class="fc" id="L146">                    this.wait(nextExpirationTime - currentTime);</span>
<span class="fc" id="L147">                    continue;</span>
                }
                SessionSet set;
<span class="fc" id="L150">                set = sessionSets.remove(nextExpirationTime);</span>
<span class="fc bfc" id="L151" title="All 2 branches covered.">                if (set != null) {</span>
<span class="fc bfc" id="L152" title="All 2 branches covered.">                    for (SessionImpl s : set.sessions) {</span>
<span class="fc" id="L153">                        setSessionClosing(s.sessionId);</span>
<span class="fc" id="L154">                        expirer.expire(s);</span>
<span class="fc" id="L155">                    }</span>
                }
<span class="fc" id="L157">                nextExpirationTime += expirationInterval;</span>
<span class="fc" id="L158">            }</span>
<span class="nc" id="L159">        } catch (InterruptedException e) {</span>
<span class="nc" id="L160">            handleException(this.getName(), e);</span>
<span class="fc" id="L161">        }</span>
<span class="fc" id="L162">        LOG.info(&quot;SessionTrackerImpl exited loop!&quot;);</span>
<span class="fc" id="L163">    }</span>

    synchronized public boolean touchSession(long sessionId, int timeout) {
<span class="pc bpc" id="L166" title="1 of 2 branches missed.">        if (LOG.isTraceEnabled()) {</span>
<span class="nc" id="L167">            ZooTrace.logTraceMessage(LOG,</span>
                                     ZooTrace.CLIENT_PING_TRACE_MASK,
                                     &quot;SessionTrackerImpl --- Touch session: 0x&quot;
<span class="nc" id="L170">                    + Long.toHexString(sessionId) + &quot; with timeout &quot; + timeout);</span>
        }
<span class="fc" id="L172">        SessionImpl s = sessionsById.get(sessionId);</span>
        // Return false, if the session doesn't exists or marked as closing
<span class="fc bfc" id="L174" title="All 4 branches covered.">        if (s == null || s.isClosing()) {</span>
<span class="fc" id="L175">            return false;</span>
        }
<span class="fc" id="L177">        long expireTime = roundToInterval(System.currentTimeMillis() + timeout);</span>
<span class="fc bfc" id="L178" title="All 2 branches covered.">        if (s.tickTime &gt;= expireTime) {</span>
            // Nothing needs to be done
<span class="fc" id="L180">            return true;</span>
        }
<span class="fc" id="L182">        SessionSet set = sessionSets.get(s.tickTime);</span>
<span class="fc bfc" id="L183" title="All 2 branches covered.">        if (set != null) {</span>
<span class="fc" id="L184">            set.sessions.remove(s);</span>
        }
<span class="fc" id="L186">        s.tickTime = expireTime;</span>
<span class="fc" id="L187">        set = sessionSets.get(s.tickTime);</span>
<span class="fc bfc" id="L188" title="All 2 branches covered.">        if (set == null) {</span>
<span class="fc" id="L189">            set = new SessionSet();</span>
<span class="fc" id="L190">            sessionSets.put(expireTime, set);</span>
        }
<span class="fc" id="L192">        set.sessions.add(s);</span>
<span class="fc" id="L193">        return true;</span>
    }

    synchronized public void setSessionClosing(long sessionId) {
<span class="pc bpc" id="L197" title="1 of 2 branches missed.">        if (LOG.isTraceEnabled()) {</span>
<span class="nc" id="L198">            LOG.info(&quot;Session closing: 0x&quot; + Long.toHexString(sessionId));</span>
        }
<span class="fc" id="L200">        SessionImpl s = sessionsById.get(sessionId);</span>
<span class="pc bpc" id="L201" title="1 of 2 branches missed.">        if (s == null) {</span>
<span class="nc" id="L202">            return;</span>
        }
<span class="fc" id="L204">        s.isClosing = true;</span>
<span class="fc" id="L205">    }</span>

    synchronized public void removeSession(long sessionId) {
<span class="fc" id="L208">        SessionImpl s = sessionsById.remove(sessionId);</span>
<span class="fc" id="L209">        sessionsWithTimeout.remove(sessionId);</span>
<span class="pc bpc" id="L210" title="1 of 2 branches missed.">        if (LOG.isTraceEnabled()) {</span>
<span class="nc" id="L211">            ZooTrace.logTraceMessage(LOG, ZooTrace.SESSION_TRACE_MASK,</span>
                    &quot;SessionTrackerImpl --- Removing session 0x&quot;
<span class="nc" id="L213">                    + Long.toHexString(sessionId));</span>
        }
<span class="pc bpc" id="L215" title="1 of 2 branches missed.">        if (s != null) {</span>
<span class="fc" id="L216">            SessionSet set = sessionSets.get(s.tickTime);</span>
            // Session expiration has been removing the sessions   
<span class="fc bfc" id="L218" title="All 2 branches covered.">            if(set != null){</span>
<span class="fc" id="L219">                set.sessions.remove(s);</span>
            }
        }
<span class="fc" id="L222">    }</span>

    public void shutdown() {
<span class="fc" id="L225">        LOG.info(&quot;Shutting down&quot;);</span>

<span class="fc" id="L227">        running = false;</span>
<span class="pc bpc" id="L228" title="1 of 2 branches missed.">        if (LOG.isTraceEnabled()) {</span>
<span class="nc" id="L229">            ZooTrace.logTraceMessage(LOG, ZooTrace.getTextTraceLevel(),</span>
                                     &quot;Shutdown SessionTrackerImpl!&quot;);
        }
<span class="fc" id="L232">    }</span>


    synchronized public long createSession(int sessionTimeout) {
<span class="fc" id="L236">        addSession(nextSessionId, sessionTimeout);</span>
<span class="fc" id="L237">        return nextSessionId++;</span>
    }

    synchronized public void addSession(long id, int sessionTimeout) {
<span class="fc" id="L241">        sessionsWithTimeout.put(id, sessionTimeout);</span>
<span class="fc bfc" id="L242" title="All 2 branches covered.">        if (sessionsById.get(id) == null) {</span>
<span class="fc" id="L243">            SessionImpl s = new SessionImpl(id, sessionTimeout, 0);</span>
<span class="fc" id="L244">            sessionsById.put(id, s);</span>
<span class="pc bpc" id="L245" title="1 of 2 branches missed.">            if (LOG.isTraceEnabled()) {</span>
<span class="nc" id="L246">                ZooTrace.logTraceMessage(LOG, ZooTrace.SESSION_TRACE_MASK,</span>
                        &quot;SessionTrackerImpl --- Adding session 0x&quot;
<span class="nc" id="L248">                        + Long.toHexString(id) + &quot; &quot; + sessionTimeout);</span>
            }
<span class="fc" id="L250">        } else {</span>
<span class="pc bpc" id="L251" title="1 of 2 branches missed.">            if (LOG.isTraceEnabled()) {</span>
<span class="nc" id="L252">                ZooTrace.logTraceMessage(LOG, ZooTrace.SESSION_TRACE_MASK,</span>
                        &quot;SessionTrackerImpl --- Existing session 0x&quot;
<span class="nc" id="L254">                        + Long.toHexString(id) + &quot; &quot; + sessionTimeout);</span>
            }
        }
<span class="fc" id="L257">        touchSession(id, sessionTimeout);</span>
<span class="fc" id="L258">    }</span>

    synchronized public void checkSession(long sessionId, Object owner) throws KeeperException.SessionExpiredException, KeeperException.SessionMovedException {
<span class="fc" id="L261">        SessionImpl session = sessionsById.get(sessionId);</span>
<span class="pc bpc" id="L262" title="1 of 4 branches missed.">        if (session == null || session.isClosing()) {</span>
<span class="fc" id="L263">            throw new KeeperException.SessionExpiredException();</span>
        }
<span class="fc bfc" id="L265" title="All 2 branches covered.">        if (session.owner == null) {</span>
<span class="fc" id="L266">            session.owner = owner;</span>
<span class="pc bpc" id="L267" title="1 of 2 branches missed.">        } else if (session.owner != owner) {</span>
<span class="nc" id="L268">            throw new KeeperException.SessionMovedException();</span>
        }
<span class="fc" id="L270">    }</span>

    synchronized public void setOwner(long id, Object owner) throws SessionExpiredException {
<span class="fc" id="L273">        SessionImpl session = sessionsById.get(id);</span>
<span class="pc bpc" id="L274" title="2 of 4 branches missed.">        if (session == null || session.isClosing()) {</span>
<span class="nc" id="L275">            throw new KeeperException.SessionExpiredException();</span>
        }
<span class="fc" id="L277">        session.owner = owner;</span>
<span class="fc" id="L278">    }</span>
}
</pre><div class="footer"><span class="right">Created with <a href="http://www.eclemma.org/jacoco">JaCoCo</a> 0.7.7.201606060606</span></div></body></html>